<?php
// $Id: node_gallery_access.inc,v 1.3.2.4 2010/08/11 22:17:23 justintime Exp $

/**
 * @file Node gallery access API file
 *
 * @param unknown_type $nid
 * @return unknown
 */

function node_gallery_access_clear_password() {
  unset($_SESSION['node_gallery_access']['passwords']); 
  drupal_set_message(t('Your passwords have been cleared from your session.'));
  drupal_goto();
}

function node_gallery_access_password_is_set() {
  return isset($_SESSION['node_gallery_access']['passwords']);  
}

function node_gallery_access_get_node_access($nid) {
  return db_fetch_object(db_query("SELECT access_type as node_gallery_access_type, password as node_gallery_access_password FROM {node_gallery_access} WHERE nid = %d", $nid));
}

function node_gallery_access_delete_node_access($nid) {
  return db_query("DELETE FROM {node_gallery_access} WHERE nid = %d", $nid);
}

function node_gallery_access_exists($nid) {
  return db_fetch_object(db_query("SELECT * FROM {node_gallery_access} WHERE nid = %d", $nid));
}

function node_gallery_access_save_node_access($node, $exists = NULL) {
  if ($node->node_gallery_access_type == NODE_GALLERY_ACCESS_TYPE_PASSTHROUGH) {
    return; 
  } 
  $access->nid = $node->nid;
  $access->uid = $node->uid;
  $access->access_type = $node->node_gallery_access_type;
  if ($access->access_type == NODE_GALLERY_ACCESS_TYPE_PASSWORD) {
    $access->password = !empty($node->node_gallery_access_password) ? node_gallery_access_set_password($node->node_gallery_access_password) : $node->old_password;
  }
  if ($exists === NULL) {
    $exists = db_result(db_query('SELECT nid FROM {node_gallery_access} WHERE nid = %d', $node->nid));
  }
  if ($exists) {
    return drupal_write_record('node_gallery_access', $access, array('nid'));
  }
  else {
    return drupal_write_record('node_gallery_access', $access);
  }
}

function node_gallery_access_set_password($raw, $oldsalt = FALSE) {
  // We use $oldsalt to remain backwards compatible - there is no way to convert old to new since it's a one-way hash
  if ($oldsalt) {
    $enc = NULL;
    $salt = 'fslkj131rlkjl';
  }
  else {
    // Prepend dpk (Drupal Private Key) to string so we know it was used
    $enc = 'dpk:';
    $salt = drupal_get_private_key();
  }
  return $enc . sha1($salt . $raw);
}

function node_gallery_access_get_types() {
  $types = variable_get('node_gallery_access_types', array());
  foreach ($types as $type) {
    if (!empty($type)) {
      $items[] = $type;
    }
  }
  return $items;
}

// Clone of drupal_get_token without the sessionid portion
function node_gallery_access_get_token($value = '') {
  $private_key = drupal_get_private_key();
  return md5($value . $private_key);
}

// Copy of drupal_valid_token without the sessionid portion
function node_gallery_access_valid_token($token, $value = '') {
  return (($token == md5($value . variable_get('drupal_private_key', ''))));
}

